package fr.mastah.mojo.bean;

import org.apache.maven.plugins.annotations.Parameter;

/**
 * Inputs that will be used by JSDoc3 for documentations.
 * 
 * <pre>
 * Format as follow:
 * 	&lt;jsdocInput&gt;
 * 		&lt;jsDir&gt;some text&lt;/jsDir&gt;
 * 		&lt;pattern&gt;some text&lt;/pattern&gt;
 * 	&lt;/jsdocInput&gt;
 * </pre>
 */
public class JSDocInput {

	/** Directory to be used for scanning files. */
	@Parameter(property = "jsdocInput.jsDir")
	private String jsDir;

	/** Pattern to be used to filter the scanning result. */
	@Parameter(property = "jsdocInput.pattern")
	private String pattern;

	/**
	 * Constructor.
	 */
	public JSDocInput() {
		this.pattern = ".*.js";
	}

	/**
	 * Getter for jsDir.
	 * 
	 * @return the jsDir.
	 */
	public final String getJsDir() {
		return this.jsDir;
	}

	/**
	 * Setter for jsDir.
	 * 
	 * @param theJsDir the jsDir to set.
	 */
	public final void setJsDir(final String theJsDir) {
		this.jsDir = theJsDir;
	}

	/**
	 * Getter for pattern.
	 * 
	 * @return the pattern.
	 */
	public final String getPattern() {
		return this.pattern;
	}

	/**
	 * Setter for pattern.
	 * 
	 * @param thePattern the pattern to set.
	 */
	public final void setPattern(final String thePattern) {
		this.pattern = thePattern;
	}

}
