package fr.mastah.mojo.process;

import java.io.IOException;
import java.io.InputStream;

import org.apache.maven.plugin.logging.Log;

/**
 * @author mastah
 */
public abstract class AbstractInputStreamHandler extends Thread {

	/** Stream being read. */
	private InputStream m_stream;

	/** The StringBuffer holding the captured output. */
	private StringBuffer m_captureBuffer;

	/** Logger. */
	private Log logger;

	/**
	 * Constructor.
	 * 
	 * @param stream
	 * @param theLogger
	 */
	public AbstractInputStreamHandler(final InputStream stream, final Log theLogger) {
		this.m_stream = stream;
		this.m_captureBuffer = new StringBuffer();
		this.logger = theLogger;
		this.start();
	}

	/**
	 * Stream the data.
	 */
	@Override
	public void run() {
		try {
			boolean hit = false;
			int nextChar;
			while ((nextChar = this.m_stream.read()) != -1) {
				this.m_captureBuffer.append((char) nextChar);
				hit = true;
			}
			if (hit) {
				this.doLog(this.m_captureBuffer);
			}
		} catch (IOException ioe) {
		}
	}

	/**
	 * Define how to log.
	 */
	public abstract void doLog(final StringBuffer theBuffer);

	/**
	 * Getter for logger.
	 * 
	 * @return the logger.
	 */
	public final Log getLogger() {
		return this.logger;
	}

}
